<?php

// This is the Spreadsheet class that is used by the Earnings Tracker application (V4.0).

// This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

// You can obtain a copy of the GNU General Public License by writing to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

// To read the GNU General Public License, go to http://www.gnu.org/licenses/gpl.html


	class Spreadsheet {

		// Variables

		var	$userID,
			$yearID,
			$year,
			$email,
			$name,
			$password,
			$month,
			$invoiced,
			$vat_amount,
			$grs_amount,
			$vat_payable,
			$vat_surplus,
			$accountancy,
			$grs_salary,
			$vat,
			$tax,
			$ni_ees,
			$ni_ers,
			$net_salary,
			$expenses,
			$interest,
			$other_rev,
			$pension,
			$deductions,
			$corporation_tax,
			$exp_div,
			$exp_pickup,
			$rec_div,
			$diff,
			$retention,
			$comments,
			$dividendID,
			$dividend_amount,
			$tax_credit,
   			$gross_dividend,
   			$period,
   			$year_end,
   			$meeting_date,
   			$company,
   			$company_address_line_1,
   			$company_address_line_2,
   			$company_address_line_3,
   			$company_address_line_4,
   			$holding,
   			$dividend_rate,
   			$recipient_name,
   			$recipient_address_line_1,
   			$recipient_address_line_2,
   			$recipient_address_line_3,
   			$recipient_address_line_4,
			$dbHost,
			$dbUser,
			$dbName,
			$dbPass,
			$dbUserTable,
			$dbSpreadsheetTable,
			$dbSalaryTable,
			$dbYearTable,
			$dbColumnTable,
			$dbDividendTable;


		// Methods

		function Spreadsheet() {
			$this->dbHost = 'enter the host name here';
			$this->dbUser = 'enter the database user name here';
			$this->dbName = 'enter the database name here';
			$this->dbPass = 'enter the database password here';
			$this->dbUserTable = 'user_v3';
			$this->dbSpreadsheetTable = 'spreadsheet_v3';
			$this->dbSalaryTable = 'salary_v3';
			$this->dbYearTable = 'year_v3';
			$this->dbColumnTable = 'display_columns';
			$this->dbDividendTable = 'dividend_payments';
		}

		function register($email, $name, $password) {
		// This method is used to register new users. It takes values from regcomplete.php.

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");
			$passcrypt = crypt($password);

			$result = mysql_query(
				"select * from $this->dbName.$this->dbUserTable where email = '$email'");
			$found = false;
			if ($result) {
				if (mysql_num_rows($result) > 0) {
					$found = true;
					header("location: registerfailed.htm");
				}
			}
			if ($found == false) {
				$result = mysql_query(
				"insert into $this->dbName.$this->dbUserTable
				(email, name, password) values
				('$email', '$name', '$passcrypt')");

				$result = mysql_query(
				"select userID from $this->dbName.$this->dbUserTable where email = '$email'");

				while ($row = mysql_fetch_assoc($result)){
					$userID = $row['userID'];
				}

				$result = mysql_query(
				"insert into $this->dbName.$this->dbSalaryTable
				(userID) values
				('$userID')");

				print "<p class=\"indent\">Thank you for registering.</p>\n";
				print "<p class=\"indent\">Click <a href=\"login.htm\">here</a> to log in.</p>\n";

			}

			mysql_close();
		}


		function checkAccess() {
		// This method is used to check whether a valid email and password combination are being used. This method can be called by any page where you want to provide user authentication. Initially, a check is made to see if an email and password have been entered on the login screen. If not, the values from the email and password cookies are used. If there was a POST, those values are used, overwriting the cookies.

			$email = $_POST['email'];
			$password = $_POST['password']; // non-encrypted here
			$remember = $_POST['remember'];

			// If no POST, check for cookies
			if ($email == NULL) {
				$email = $_COOKIE['spreadsheetemail'];
				$password = $_COOKIE['spreadsheetpassword']; // non-encrypted here
			}
			else {
				// If there was a POST, save the cookies
				setcookie('spreadsheetemail', $email);
				setcookie('spreadsheetpassword', $password); // non-encrypted here
			}

			$okay = false;
			if ($email && $password) {
				mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");
				$result = mysql_query(
					"select * from $this->dbName.$this->dbUserTable where email = '$email'"
				);
				if ($result) {
					if (mysql_num_rows($result) > 0) {
						$row = mysql_fetch_assoc($result);
						$pass = $row['password']; // encrypted here
						$name = $row['name'];
						$email = $row['email'];
						$userID = $row['userID'];

						// Check to see whether the new user is the same as the previous user to use the application on this machine. If the users are not the same, the newUser.htm page is displayed, which tells the new user to confirm his static values details.
						$oldUserID = $_COOKIE['user'];

						if ($oldUserID != $userID){
						header("location: newUser.htm");
						}

						// Check that password is correct.
						// This is for when MD5 is used
						$passcrypt = crypt($password,
							substr($pass, 0, 12));
						// If DES is used, just use
						// $passcrypt = crypt($password);
						if ($pass == $passcrypt) {
							$okay = true;
						}
					}
				}
				mysql_close();
			}
			if (!$okay) {
				header("location: loginfailed.php");
			}

			// If $remember is set, store in long-term cookie
			if ($remember) {
				// Remember until May 17, 2033.
				setcookie('spreadsheetemail', $email, 2000000000);
				setcookie('spreadsheetpassword', $password, 2000000000);
				setcookie('rememberme', 1, 2000000000);
		}

			// Assign values to the data members so that they can be used in other methods
			$this->name = $name;
			$this->password = $password; // non-encrypted here
			$this->email = $email;
			$this->userID = $userID;

			// This cookie is used to check whether the user has changed for the current client computer
			setcookie('user', $userID, 2000000000);
		}

		function updateDetails() {
		// This method is used as part of the process to enable a user to update their details once they have successfully logged on. It is called by updateDetails.php. It presents a form to the user. The data from the form is passed to updateDetails1.php.
		?>

			<script language="JavaScript">
			function IsNotNull(){
				if (document.form1.email == null ||
					document.form1.name == null ||
					document.form1.password == null ||
					document.form1.password1 == null) {
					alert("Please fill out all the fields.");
					return false;
				}
					if (document.form1.email.value.length == 0 ||
						document.form1.name.value.length == 0 ||
						document.form1.password.value.length == 0 ||
						document.form1.password1.value.length == 0) {
						alert("Please fill out all the fields.");
						return false;
					}
					return true;
			}

			function IsValidEmail(){
				var email = document.form1.email.value;
				var myreg
					= /^[^@\s]+@([-a-z0-9]+\.)+[a-z]{2,}$/
				if (myreg.test(email)) {
					return true;
				}
				else {
					alert("The email address is invalid.");
					return false;
				}
			}

			function CheckForMatch() {
				if (document.form1.password.value !=
					document.form1.password1.value) {
					alert("The passwords do not match.\n"+
						"Please re-enter them. Thanks");
					return false;
				}
				return true;
			}

			function checkfields() {
				if (IsNotNull() == false) {
					return false;
				}
				if (IsValidEmail() == false) {
					return false;
				}
				if (CheckForMatch() == false) {
					return false;
				}
				return true;
			}
			</script>

			<?php

			print "<h3>Update Profile</h3>\n";

			print "<table cellpadding=\"6\">\n";
			print "<tr>\n";
			print "<td bgcolor=\"#E0F0F0\" style=\"border-top:1px solid #009999;border-right:4px solid #009999;border-left:1px solid #009999;border-bottom:1px solid #009999;\">\n";
			print "<form name=\"form1\" action=\"updateDetails1.php\" onSubmit='return checkfields();' method=\"post\">\n";
			print "<input type=\"hidden\" name=\"userID\" value=$this->userID>\n";
			print "<p>Name: <input type=\"text\" name=\"name\" value=$this->name></p>\n";
			print "<p>Email address: <input type=\"text\" name=\"email\" value=$this->email></p>\n";
			print "<p>Choose a password: <input type=\"password\" name=\"password\" value=$this->password></p>\n";
			print "<p>Retype password: <input type=\"password\" name=\"password1\" value=$this->password></p>\n";
			print "<br>\n";
			print "<input type=\"submit\" value=\"Update Details\"> <input type=\"reset\">\n";
			print "</form>\n";
			print "</td>\n";
			print "</tr>\n";
			print "</table>\n";
		}

		function updateDetails1($userID, $name, $email, $password) {
		// This method is used as part of the process to enable a user to update their details. It is called by updateDetails1.php.

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

			$passcrypt = crypt($password);

			$result = mysql_query("update $this->dbName.$this->dbUserTable set name='$name', email='$email', password='$passcrypt' where userID='$userID'");

			// If update worked, display success message
			if ($result) {
				print "<p class=\"indent\">Your details have been updated.</p>\n";

				print "<p class=\"indent\">Click <a href=\"login.htm\">here</a> to log back in.</p>\n";
			}

			// If update did not work, display an error message
			else {
				print "<p class=\"indent\">There was a problem updating your details.</p>\n";
			}

			mysql_close();
		}

		function genPass($email) {

		// This method is called by genPass.php. A check is initially made to see whether the email address entered in newpassword.htm is valid. If it is, a new password is generated. The new password is either displayed on the screen (for the demo version of the application) or emailed to the user (for the production version). An encrypted password is written to the database. The user is then prompted to log in again.

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

			$result = mysql_query(
				"select * from $this->dbName.$this->dbUserTable where email = '$email'"
				);

			$found = false;
			if ($result) {
				if (mysql_num_rows($result) > 0) {
				$found = true;
				}
			}

			if (!$found) {
				print "<p class=\"indent\">Sorry, can't find that email address.</p>";
				print '<p class=\"indent\">Click <a href="newpassword.htm">here</a> to try again</p>';
			}
			else {
			// Generate a new password
				$letterlist = array("a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z");
				$firstletter = $letterlist[rand(0,
					count($letterlist) - 1)];
				$secondletter = $letterlist[rand(0,
					count($letterlist) - 1)];
				$thirdletter = $letterlist[rand(0,
					count($letterlist) - 1)];
				$fourthletter = $letterlist[rand(0,
					count($letterlist) - 1)];
				$fifthletter = $letterlist[rand(0,
					count($letterlist) - 1)];
				$sixthletter = $letterlist[rand(0,
					count($letterlist) - 1)];
				$number1 = rand(10,99);
				$number2 = rand(10,99);
				$newpass = $firstletter.$number1.$secondletter.$thirdletter.$fourthletter.$number2.$fifthletter.$sixthletter;
				$newpasscrypt = crypt($newpass);

			// For production version, comment out the following two lines
			//print "<p class=\"indent\">Your new password is $newpass</p>\n";
			//print "<p class=\"indent\">(On a live system this would be emailed.)</p>\n";

			$result = mysql_query("update $this->dbName.$this->dbUserTable set password = '$newpasscrypt' where email = '$email'");

			//  For production version uncomment the following lines
				mail($email, "Password request",
						"Your new password is\n".
						"$newpass\n".
						"Please remember it.");
					print "<p class=\"indent\">A new password has been emailed to you</p>\n";

			print "<p class=\"indent\">Click <a href=\"login.htm\">here</a> to log in</p>\n";
			}
			mysql_close();
		}


		function getSalary() {
			// This method is used as part of the process to enable a user to set some values that do not generally change on a monthly basis. It is called by setSalary.php. It provides a form to the user. The data from the form is sent to salary.php.

			?>

			<!-- JavaScript to check that valid data is entered -->

			<script language="JavaScript">

			function IsValidSalary(){
				var salary = document.form1.grs_salary.value;
				var myreg
					= /(\d+\.\d+)|(\d+)/
				if (myreg.test(salary)) {
					return true;
				}
				else {
					alert("You have entered an invalid monthly salary.");
					return false;
				}
			}

			function IsValidVat(){
				var vat = document.form1.vat.value;
				var myreg
					= /(\d+\.\d+)|(\d+)|/
				if (myreg.test(vat)) {
					return true;
				}
				else {
					alert("You have entered an invalid VAT flat rate percentage.");
					return false;
				}
			}

			function IsValidAccountancy(){
				var vat = document.form1.accountancy.value;
				var myreg
					= /(\d+\.\d+)|(\d+)|/
				if (myreg.test(accountancy)) {
					return true;
				}
				else {
					alert("You have entered an invalid accountancy fee.");
					return false;
				}
			}

			function checkfields() {
				if (IsValidSalary() == false) {
					return false;
				}
				if (IsValidVat() == false) {
					return false;
				}
				if (IsValidAccountancy() == false) {
					return false;
				}
				return true;
			}
			</script>

			<?php


			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

			$result = @mysql_query(
			"select * from $this->dbName.$this->dbSalaryTable where userID='$this->userID'");

			while ($row = @mysql_fetch_assoc($result)){

				$grs_salary = $row['grs_salary'];
				$vat = $row['vat'];
				$accountancy = $row['accountancy'];
				}

			?>

			<h3>Set Static Values</h3>

			<p>Use this form to enter values that generally remain the same from month to month. This is simply to prevent you from needing to enter them on the 'Add Month' form.</p>

			<p>You can modify these values whenever you want to.</p>

			<br>

			<table cellpadding="6">
			<tr>
			<td bgcolor="#E0F0F0" style="border-top:1px solid #009999;border-right:4px solid #009999;border-left:1px solid #009999;border-bottom:1px solid #009999;">
			<form name="form1" method="post" action="salary.php" onSubmit='return checkfields();'>

			<input type="hidden" name="userID" value="<? echo "$this->userID" ?>">

			<p>Gross Monthly Salary: <input type="text" name="grs_salary" maxlength="9" size="9" value="<? echo "$grs_salary" ?>"></p>
			<p>VAT Flat Rate Percentage: <input type="text" name="vat" maxlength="9" size="9" value="<? echo "$vat" ?>"></p>
			<p>Monthly Accountancy Fee:* <input type="text" name="accountancy" maxlength="9" size="9" value="<? echo "$accountancy" ?>"></p>
			<br>
			<p><input type="submit" name="Submit" value="Update/Confirm Values"></p>
			</form>
			</td>
			</tr>
			</table>

			<?php

		mysql_close();

		}


		function setSalary($grs_salary, $vat, $accountancy, $userID) {
		// This method is used as part of the process to enable a user to set a salary, vat flat rate and accountancy fee. It is called by salary.php.

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

			$result = @mysql_query(
			"update $this->dbName.$this->dbSalaryTable set grs_salary='$grs_salary', vat='$vat', accountancy='$accountancy' where userID='$userID'");

			// If update/insert worked, display success message
			if ($result) {
				print "<p class=\"indent\"><b>The values have been set</b></p>\n";

				print "<br>\n";

				print "<p class=\"indent\">The following table summarises the main tasks you can perform.</p>\n";

				print "<table width=\"700\" align=\"left\">\n";
				print "<tr>\n";
				print "<td valign=\"top\" width=\"200\"><p class=\"indent\">Add Month</p>\n";
				print "</td>\n";
				print "<td valign=\"top\"><p>Use this menu option to add a new month to the spreadsheet.</p>\n";
				print "</td>\n";
				print "</tr>\n";
				print "<tr>\n";
				print "<td valign=\"top\"><p class=\"indent\">View/Edit Spreadsheet</p>\n";
				print "</td>\n";
				print "<td valign=\"top\"><p>Use this menu option to view and edit existing months. You can also delete months.\n";
				print "</td>\n";
				print "</tr>\n";
				print "</table>\n";
			}

			// If update/insert did not work, display error message
			else {
				print "<p class=\"indent\">There was a problem setting the values.</p>\n";
			}

			mysql_close();

		}


		function addRow($yearID, $month, $invoiced, $tax, $ni_ees, $ni_ers, $expenses, $interest, $other_rev, $pension, $deductions, $rec_div, $comments) {

		// This method adds a new row to the spreadsheet. It is called by addRow.php.

		mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

		$result = @mysql_query(
			"select * from $this->dbName.$this->dbSalaryTable where userID='$this->userID'");

		while ($row = @mysql_fetch_assoc($result)){

			$grs_salary = $row['grs_salary'];
			// VAT flat rate percentage
			$vat = $row['vat'];

			// Change VAT flat rate percentage to a multiplier
			// Eg change 12.00 to 0.12

  			$vat=$vat/100;

			$accountancy = $row['accountancy'];
			}

			// Calculate VAT
			$vat_amount=$invoiced*0.175;

			// Calculate gross receivable
			$grs_amount=$invoiced+$vat_amount;

			// Calculate VAT payable (accrued VAT)
			$vat_payable=$vat*$grs_amount;

			// Calculate VAT surplus (VAT charged - VAT payable)
			$vat_surplus=$vat_amount-$vat_payable;

			// Calculate net salary
			$net_salary=$grs_salary-($ni_ees+$tax);

			// Calculate corporation tax due
			$corporation_tax_temp=($invoiced+$interest+$other_rev+$vat_surplus)-($accountancy+$grs_salary+$ni_ers+$deductions+$expenses+$pension);

			$corporation_tax=0.21*$corporation_tax_temp;

			// Calculate maximum dividend
			$exp_div=($invoiced+$interest+$other_rev+$vat_surplus)-($accountancy+$grs_salary+$ni_ers+$deductions+$expenses+$pension+$corporation_tax);

			// Calculate the expected pickup
			$exp_pickup=$exp_div+$net_salary+$expenses;

			// Calculate the difference between the dividend taken and the maximum dividend
			// available
			$diff=$exp_div-$rec_div;

			// Check to make sure that there is an invoice amount.
			if ($invoiced > 0){
			$retention=100*($exp_pickup/$invoiced);
			}
			else {
			$retention=0.00;
			}

			// Check that more money has come in than has gone out
			$overpaymentCheck=($invoiced+$interest+$other_rev+$vat_surplus)-($accountancy+$grs_salary+$ni_ers+$deductions+$expenses+$rec_div+$pension+$corporation_tax);
			$outgoings=$accountancy+$grs_salary+$ni_ers+$deductions+$expenses+$rec_div+$pension+$corporation_tax;

			if ($overpaymentCheck<0.00){
			print "<p class=\"indent\">In $month, your company invoiced $invoiced, received $interest in bank interest, other revenue of $other_rev, plus a VAT surplus of $vat_surplus, but your salary, accountancy fee, employers NI, expenses taken, dividend taken, pension contributions, corporation tax, and any other deductions came to $outgoings. This gives a negative amount for this month of $overpaymentCheck. The running totals at the bottom of the spreadsheet, give the overall situation for this year.</p>\n" ;
			}

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

			// Determine whether the month has already been entered
			$findmonth = mysql_query(
				"select * from $this->dbName.$this->dbSpreadsheetTable where month='$month' and userID='$this->userID' and yearID='$yearID'"
				);

			$numrows = mysql_num_rows($findmonth);

			if ($numrows == 0) {

				$result = mysql_query(
					"insert into $this->dbName.$this->dbSpreadsheetTable
					(yearID, month, invoiced, vat_amount, grs_amount, vat_payable, vat_surplus, accountancy, tax, ni_ees, ni_ers, net_salary, expenses, interest, other_rev, pension, deductions, corporation_tax, exp_div, exp_pickup, rec_div, diff, retention, comments, grs_salary, userID) values
					('$yearID', '$month', '$invoiced', '$vat_amount', '$grs_amount', '$vat_payable', '$vat_surplus', '$accountancy', '$tax', '$ni_ees', '$ni_ers', '$net_salary', '$expenses', '$interest', '$other_rev', '$pension', '$deductions', '$corporation_tax', '$exp_div', '$exp_pickup', '$rec_div', '$diff', '$retention', '$comments', '$grs_salary', '$this->userID')");

					if ($result) {
						print "<p class=\"indent\">The new row has been added.</p>\n";
					}

					else {
						print "<p class=\"indent\">The new row has NOT been added.</p>\n";
					}
				}

			else {
				print "<p class=\"indent\">You already have an entry for $month. The new row has not been added.</p>\n";
				}

			mysql_close();
		}


		function selectYear() {

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

			print "<h3>View/Edit Spreadsheet</h3>\n";

			print "<table cellpadding=\"6\">\n";
			print "<tr>\n";
			print "<td bgcolor=\"#E0F0F0\" style=\"border-top:1px solid #009999;border-right:4px solid #009999;border-left:1px solid #009999;border-bottom:1px solid #009999;\">\n";

			print "<form name=\"form1\" method=\"post\" action=\"viewRows.php\">\n";

			print "<br>\n";

			print "<table><tr>\n";

			print "<td valign=\"top\" width=\"195px\">\n";

			$result = @mysql_query("select * from $this->dbName.$this->dbYearTable");

			print "<p style=\"text-align:center\">Select a year:\n";

			print "<select name=\"yearID\">\n";

			while ($row = mysql_fetch_assoc($result)){

				$yearID = $row['yearID'];
				$year = $row['year'];

				print "<option value=$yearID\n";

				if ($yearID == 2) {
					print " selected\n";
				}

				print ">$year\n";
			}

			print "</select>\n";

			print "</p>\n";

			print "<p style=\"text-align:center;\">&nbsp;<input type=\"submit\" name=\"Submit\" value=\"View/Edit Spreadsheet\">&nbsp;</p>\n";

			print "</td>\n";

			print "<td width=\"5px\">\n";
			print "&nbsp;\n";
			print "</td>\n";

			print "<td style=\"border:1px solid #009999;padding:10px;margin-right:20px;\" valign=\"top\" align=\"left\" width=\"455px\">\n";

			print "<p style=\"text-align:center;\"><b>Select columns to display on spreadsheet</b>\n";

			$result = @mysql_query("select * from $this->dbName.$this->dbColumnTable");

			while ($row = mysql_fetch_assoc($result)){

				$show_invoiced = $row['show_invoiced'];
				$show_vat = $row['show_vat'];
				$show_gross = $row['show_gross'];
				$show_vat_payable = $row['show_vat_payable'];
				$show_vat_surplus = $row['show_vat_surplus'];
				$show_accountancy = $row['show_accountancy'];
				$show_gross_salary = $row['show_gross_salary'];
				$show_tax = $row['show_tax'];
				$show_employees_ni = $row['show_employees_ni'];
				$show_employers_ni = $row['show_employers_ni'];
				$show_net_salary = $row['show_net_salary'];
				$show_expenses = $row['show_expenses'];
				$show_interest = $row['show_interest'];
				$show_other_rev = $row['show_other_rev'];
				$show_pension = $row['show_pension'];
				$show_deductions = $row['show_deductions'];
				$show_corporation_tax = $row['show_corporation_tax'];
				$show_exp_div = $row['show_exp_div'];
				$show_exp_pickup = $row['show_exp_pickup'];
				$show_div_rec = $row['show_div_rec'];
				$show_diff = $row['show_diff'];
				$show_retention = $row['show_retention'];
				$show_comments = $row['show_comments'];

			}

			print "<table>\n";
			print "<tr>\n";
			print "<td valign=\"top\">\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_invoiced\"\n";
			if ($show_invoiced==Y){
				print "checked\n";
			}
			print ">Invoiced Amount (Net)</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_vat\"\n";
			if ($show_vat==Y){
				print "checked\n";
			}
			print ">VAT Chargeable</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_gross\"\n";
			if ($show_gross==Y){
				print "checked\n";
			}
			print ">Invoiced Amount (Gross)</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_vat_payable\"\n";
			if ($show_vat_payable==Y){
				print "checked\n";
			}
			print ">VAT Payable (Flat Rate Scheme)</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_vat_surplus\"\n";
			if ($show_vat_surplus==Y){
				print "checked\n";
			}
			print ">VAT Surplus (VAT Chargeable - VAT Payable)</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_accountancy\"\n";
			if ($show_accountancy==Y){
				print "checked\n";
			}
			print ">Accountancy Fee</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_gross_salary\"\n";
			if ($show_gross_salary==Y){
				print "checked\n";
			}
			print ">Gross Salary</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_tax\"\n";
			if ($show_tax==Y){
				print "checked\n";
			}
			print ">Income Tax on Salary(ies)</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_employees_ni\"\n";
			if ($show_employees_ni==Y){
				print "checked\n";
			}
			print ">Employees NI on Salary(ies)</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_employers_ni\"\n";
			if ($show_employers_ni==Y){
				print "checked\n";
			}
			print ">Employers NI on Salary(ies)</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_net_salary\"\n";
			if ($show_net_salary==Y){
				print "checked\n";
			}
			print ">Net Salary(ies)</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_expenses\"\n";
			if ($show_expenses==Y){
				print "checked\n";
			}
			print ">Expenses</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_interest\"\n";
			if ($show_interest==Y){
				print "checked\n";
			}
			print ">Bank Interest</p>\n";

			print "</td><td valign=\"top\">\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_other_rev\"\n";
			if ($show_other_rev==Y){
				print "checked\n";
			}
			print ">Other Revenue</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_pension\"\n";
			if ($show_pension==Y){
				print "checked\n";
			}
			print ">Pension Contributions</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_deductions\"\n";
			if ($show_deductions==Y){
				print "checked\n";
			}
			print ">Deductions</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_corporation_tax\"\n";
			if ($show_corporation_tax==Y){
				print "checked\n";
			}
			print ">Corporation Tax</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_exp_div\"\n";
			if ($show_exp_div==Y){
				print "checked\n";
			}
			print ">Expected Dividend</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_exp_pickup\"\n";
			if ($show_exp_pickup==Y){
				print "checked\n";
			}
			print ">Expected Pickup</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_div_rec\"\n";
			if ($show_div_rec==Y){
				print "checked\n";
			}
			print ">Dividend Taken</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_diff\"\n";
			if ($show_diff==Y){
				print "checked\n";
			}
			print ">Difference (Expected Dividend - Dividend Taken)</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_retention\"\n";
			if ($show_retention==Y){
				print "checked\n";
			}
			print ">Retention</p>\n";

			print "<p style=\"text-align:left;\"><input type=\"checkbox\" name=\"show_comments\"\n";
			if ($show_comments==Y){
				print "checked\n";
			}
			print ">Comments</p>\n";

			print "</td></tr></table>\n";

			print "</td>\n";

			print "</tr>\n";

			print "</table>\n";

			print "</form>\n";

			print "</td>\n";
			print "</tr>\n";
			print "</table>\n";

		}


		function viewRows() {

			$yearID=$_POST['yearID'];

			$show_invoiced=$_POST['show_invoiced'];
				if ($show_invoiced==on){$show_invoiced="Y";}else{$show_invoiced="N";}

			$show_vat=$_POST['show_vat'];
				if ($show_vat==on){$show_vat="Y";}else{$show_vat="N";}

			$show_gross=$_POST['show_gross'];
				if ($show_gross==on){$show_gross="Y";}else{$show_gross="N";}

			$show_vat_payable=$_POST['show_vat_payable'];
				if ($show_vat_payable==on){$show_vat_payable="Y";}else{$show_vat_payable="N";}

			$show_vat_surplus=$_POST['show_vat_surplus'];
				if ($show_vat_surplus==on){$show_vat_surplus="Y";}else{$show_vat_surplus="N";}

			$show_accountancy=$_POST['show_accountancy'];
				if ($show_accountancy==on){$show_accountancy="Y";}else{$show_accountancy="N";}

			$show_gross_salary=$_POST['show_gross_salary'];
				if ($show_gross_salary==on){$show_gross_salary="Y";}else{$show_gross_salary="N";}

			$show_tax=$_POST['show_tax'];
				if ($show_tax==on){$show_tax="Y";}else{$show_tax="N";}

			$show_employees_ni=$_POST['show_employees_ni'];
				if ($show_employees_ni==on){$show_employees_ni="Y";}else{$show_employees_ni="N";}

			$show_employers_ni=$_POST['show_employers_ni'];
				if ($show_employers_ni==on){$show_employers_ni="Y";}else{$show_employers_ni="N";}

			$show_net_salary=$_POST['show_net_salary'];
				if ($show_net_salary==on){$show_net_salary="Y";}else{$show_net_salary="N";}

			$show_expenses=$_POST['show_expenses'];
				if ($show_expenses==on){$show_expenses="Y";}else{$show_expenses="N";}

			$show_interest=$_POST['show_interest'];
				if ($show_interest==on){$show_interest="Y";}else{$show_interest="N";}

			$show_other_rev=$_POST['show_other_rev'];
				if ($show_other_rev==on){$show_other_rev="Y";}else{$show_other_rev="N";}

			$show_pension=$_POST['show_pension'];
				if ($show_pension==on){$show_pension="Y";}else{$show_pension="N";}

			$show_deductions=$_POST['show_deductions'];
				if ($show_deductions==on){$show_deductions="Y";}else{$show_deductions="N";}

			$show_corporation_tax=$_POST['show_corporation_tax'];
				if ($show_corporation_tax==on){$show_corporation_tax="Y";}else{$show_corporation_tax="N";}

			$show_exp_div=$_POST['show_exp_div'];
				if ($show_exp_div==on){$show_exp_div="Y";}else{$show_exp_div="N";}

			$show_exp_pickup=$_POST['show_exp_pickup'];
				if ($show_exp_pickup==on){$show_exp_pickup="Y";}else{$show_exp_pickup="N";}

			$show_div_rec=$_POST['show_div_rec'];
				if ($show_div_rec==on){$show_div_rec="Y";}else{$show_div_rec="N";}

			$show_diff=$_POST['show_diff'];
				if ($show_diff==on){$show_diff="Y";}else{$show_diff="N";}

			$show_retention=$_POST['show_retention'];
				if ($show_retention==on){$show_retention="Y";}else{$show_retention="N";}

			$show_comments=$_POST['show_comments'];
				if ($show_comments==on){$show_comments="Y";}else{$show_comments="N";}

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

			// Insert column display selections into display_columns table

			$result2 = mysql_query(
				"UPDATE $this->dbName.$this->dbColumnTable
				SET show_invoiced = '$show_invoiced',
				show_vat = '$show_vat',
				show_gross = '$show_gross',
				show_vat_payable = '$show_vat_payable',
				show_vat_surplus = '$show_vat_surplus',
				show_accountancy = '$show_accountancy',
				show_gross_salary = '$show_gross_salary',
				show_tax = '$show_tax',
				show_employees_ni = '$show_employees_ni',
				show_employers_ni = '$show_employers_ni',
				show_net_salary = '$show_net_salary',
				show_expenses = '$show_expenses',
				show_interest = '$show_interest',
				show_other_rev = '$show_other_rev',
				show_pension = '$show_pension',
				show_deductions = '$show_deductions',
				show_corporation_tax = '$show_corporation_tax',
				show_exp_div = '$show_exp_div',
				show_exp_pickup = '$show_exp_pickup',
				show_div_rec = '$show_div_rec',
				show_diff = '$show_diff',
				show_retention = '$show_retention',
				show_comments = '$show_comments'
				");

			$result1 = @mysql_query(
				"select year from $this->dbName.$this->dbYearTable where yearID='$yearID'");

			while ($row = @mysql_fetch_assoc($result1)){
				$year = $row['year'];
			}

			$result = @mysql_query(
				"select monthID,month,invoiced,vat_amount,grs_amount,vat_payable,vat_surplus,accountancy,tax,ni_ees,ni_ers,net_salary,expenses,interest,other_rev,pension,deductions,corporation_tax,exp_div,exp_pickup,rec_div,diff,retention,comments,grs_salary

				from
				$this->dbName.$this->dbSpreadsheetTable
				where userID='$this->userID' and yearID='$yearID'

				ORDER by monthID");

			?>

			<form method="post" action="deleteRow.php">

			<table border="0" cellpadding="6" cellspacing="0" style="border-top:1px solid #009999;border-right:1px solid #009999;border-left:1px solid #009999;border-bottom:1px solid #009999;">
			<tr>
			<td colspan="28" bgcolor="#E0F0F0">

			<?php
			print "<p><b>Financial Year:&nbsp; $year</b></p>\n";
			?>

			</td>
			</tr>
			<tr>

			<td bgcolor="#E0F0F0" style="border-right:1px solid #009999;border-bottom:1px solid #009999;">&nbsp;</td>

			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center">&nbsp;<b>Month</b>&nbsp;<br><br>(Click to edit)</p></td>

			<?php
			if ($show_invoiced==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Amount<br>Invoiced</b></p></td>
			<?php
			}

			if ($show_vat==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>VAT<br>Charged</b></p></td>
			<?php
			}

			if ($show_gross==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Gross<br>Receivable</b></p></td>
			<?php
			}


			if ($show_vat_payable==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>VAT<br>Payable</b><br>(Flat Rate x Gross Receivable)</p></td>
			<?php
			}


			if ($show_vat_surplus==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>VAT<br>Surplus</b><br>(VAT Charged - VAT Payable)</p></td>
			<?php
			}

			if ($show_accountancy==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Accountancy<br>Fee</b></p></td>
			<?php
			}

			if ($show_gross_salary==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Gross<br>Monthly<br>Salary</b></p></td>
			<?php
			}

			if ($show_tax==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Income<br>Tax</b></p></td>
			<?php
			}

			if ($show_employees_ni==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>NI<br>Employees</b></p></td>
			<?php
			}

			if ($show_employers_ni==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>NI<br>Employers</b></p></td>
			<?php
			}

			if ($show_net_salary==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Net<br>Salary</b></p></td>
			<?php
			}

			if ($show_interest==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Bank<br>Interest</b></p></td>
			<?php
			}

			if ($show_other_rev==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Other<br>Revenue</b></p></td>
			<?php
			}

			if ($show_expenses==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Expenses<br>Taken</b></p></td>
			<?php
			}

			if ($show_pension==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Pension<br>Contributions</b></p></td>
			<?php
			}

			if ($show_deductions==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Other<br>Deductions</b></p></td>
			<?php
			}

			if ($show_corporation_tax==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Corporation<br>Tax Due</b></p></td>
			<?php
			}

			if ($show_exp_div==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Maximum<br>Dividend<br>that can<br>be taken</b></p></td>
			<?php
			}

			if ($show_exp_pickup==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Expected<br>Total<br>Pickup</b></p></td>
			<?php
			}

			if ($show_div_rec==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Actual<br>Dividend<br>Taken</b></p></td>
			<?php
			}

			if ($show_diff==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Difference</b><br>(between<br>div. available<br>and div. taken)</p></td>
			<?php
			}

			if ($show_retention==Y){
			?>
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center"><p style="text-align:center"><b>Expected<br>Retention</b></p></td>
			<?php
			}

			if ($show_comments==Y){
			?>
			<td valign="top" style="border-bottom:1px solid #009999;border-top:1px solid #009999;text-align:center;"><p style="text-align:center"><b>Comments</b></p></td>
			<?php
			}
			?>

			</tr>

			<?php

			while ($row = @mysql_fetch_assoc($result)){

				$monthID = $row['monthID'];
				$month = $row['month'];

				print "<tr>\n";

        		print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\">\n";

        		# Create an array to store all the selected month ids, which will
        		# be sent to deleteRow.php

		    	print "<p style=\"text-align:center;\"><input type=\"checkbox\" name=\"monthID[]\" value=\"$monthID\"></p>\n";
        		print "</td>\n";

				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\"><a href=\"editRow.php?month=$month&userID=$this->userID&yearID=$yearID\">$month</a></p></td>\n";


				if ($show_invoiced==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['invoiced']}</p></td>\n";
				}

				if ($show_vat==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['vat_amount']}</p></td>\n";
				}

				if ($show_gross==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['grs_amount']}</p></td>\n";
				}

				if ($show_vat_payable==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['vat_payable']}</p></td>\n";
				}

				if ($show_vat_surplus==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['vat_surplus']}</p></td>\n";
				}

				if ($show_accountancy==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['accountancy']}</p></td>\n";
				}

				if ($show_gross_salary==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['grs_salary']}</p></td>\n";
				}

				if ($show_tax==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['tax']}</p></td>\n";
				}

				if ($show_employees_ni==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['ni_ees']}</p></td>\n";
				}

				if ($show_employers_ni==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['ni_ers']}</p></td>\n";
				}

				if ($show_net_salary==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['net_salary']}</p></td>\n";
				}

				if ($show_interest==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['interest']}</p></td>\n";
				}

				if ($show_other_rev==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['other_rev']}</p></td>\n";
				}

				if ($show_expenses==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['expenses']}</p></td>\n";
				}

				if ($show_pension==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['pension']}</p></td>\n";
				}

				if ($show_deductions==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['deductions']}</p></td>\n";
				}

				if ($show_corporation_tax==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['corporation_tax']}</p></td>\n";
				}

				if ($show_exp_div==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['exp_div']}</p></td>\n";
				}

				if ($show_exp_pickup==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['exp_pickup']}</p></td>\n";
				}

				if ($show_div_rec==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['rec_div']}</p></td>\n";
				}

				if ($show_diff==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['diff']}</p></td>\n";
				}

				if ($show_retention==Y){
				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p>{$row['retention']}%</p></td>\n";
				}

				if ($show_comments==Y){
				print "<td valign=\"top\" style=\"border-bottom:1px solid #009999;\"><p>{$row['comments']}</p></td>\n";
				}

				print "</tr>\n";

			}


			// Year Totals
			print "<tr><td colspan=\"28\" style=\"border-bottom:1px solid #009999;\">&nbsp;</td></tr>\n";
			print "<tr>\n";
			print "<td colspan=\"2\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p><b>Year Totals</b></p></td>\n";

			if ($show_invoiced==Y){
			$result = @mysql_query(
				"select SUM(invoiced) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_vat==Y){
			$result = @mysql_query(
				"select SUM(vat_amount) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_gross==Y){
			$result = @mysql_query(
				"select SUM(grs_amount) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_vat_payable==Y){
			$result = @mysql_query(
				"select SUM(vat_payable) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_vat_surplus==Y){
			$result = @mysql_query(
				"select SUM(vat_surplus) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_accountancy==Y){
			$result = @mysql_query(
				"select SUM(accountancy) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_gross_salary==Y){
			$result = @mysql_query(
				"select SUM(grs_salary) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_tax==Y){
			$result = @mysql_query(
				"select SUM(tax) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_employees_ni==Y){
			$result = @mysql_query(
				"select SUM(ni_ees) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_employers_ni==Y){
			$result = @mysql_query(
				"select SUM(ni_ers) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_net_salary==Y){
			$result = @mysql_query(
				"select SUM(net_salary) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_interest==Y){
			$result = @mysql_query(
				"select SUM(interest) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_other_rev==Y){
			$result = @mysql_query(
				"select SUM(other_rev) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_expenses==Y){
			$result = @mysql_query(
				"select SUM(expenses) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_pension==Y){
			$result = @mysql_query(
				"select SUM(pension) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_deductions==Y){
			$result = @mysql_query(
				"select SUM(deductions) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_corporation_tax==Y){
			$result = @mysql_query(
				"select SUM(corporation_tax) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_exp_div==Y){
			$result = @mysql_query(
				"select SUM(exp_div) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_exp_pickup==Y){
			$result = @mysql_query(
				"select SUM(exp_pickup) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_div_rec==Y){
			$result = @mysql_query(
				"select SUM(rec_div) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_diff==Y){
			$result = @mysql_query(
				"select SUM(diff) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_retention==Y){
			$result = @mysql_query(
				"select ROUND(AVG(retention),2) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID' and yearID='$yearID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\"><p>$field%</p></td>\n";
			}
			}

			if ($show_comments==Y){
			print "<td bgcolor=\"#E0F0F0\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999\">&nbsp;</td>\n";
			}

			print "</tr>\n";


			// Grand Totals
			print "<tr><td colspan=\"28\" style=\"border-bottom:1px solid #009999;\">&nbsp;</td></tr>\n";
			print "<tr>\n";
			print "<td colspan=\"2\" style=\"border-right:1px solid #009999\"><p><b>Grand Totals</b></p></td>\n";

			if ($show_invoiced==Y){
			$result = @mysql_query(
				"select SUM(invoiced) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_vat==Y){
			$result = @mysql_query(
				"select SUM(vat_amount) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_gross==Y){
			$result = @mysql_query(
				"select SUM(grs_amount) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_vat_payable==Y){
			$result = @mysql_query(
				"select SUM(vat_payable) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_vat_surplus==Y){
			$result = @mysql_query(
				"select SUM(vat_surplus) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_accountancy==Y){
			$result = @mysql_query(
				"select SUM(accountancy) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_gross_salary==Y){
			$result = @mysql_query(
				"select SUM(grs_salary) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_tax==Y){
			$result = @mysql_query(
				"select SUM(tax) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_employees_ni==Y){
			$result = @mysql_query(
				"select SUM(ni_ees) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_employers_ni==Y){
			$result = @mysql_query(
				"select SUM(ni_ers) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_net_salary==Y){
			$result = @mysql_query(
				"select SUM(net_salary) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_interest==Y){
			$result = @mysql_query(
				"select SUM(interest) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_other_rev==Y){
			$result = @mysql_query(
				"select SUM(other_rev) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_expenses==Y){
			$result = @mysql_query(
				"select SUM(expenses) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_pension==Y){
			$result = @mysql_query(
				"select SUM(pension) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_deductions==Y){
			$result = @mysql_query(
				"select SUM(deductions) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_corporation_tax==Y){
			$result = @mysql_query(
				"select SUM(corporation_tax) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_exp_div==Y){
			$result = @mysql_query(
				"select SUM(exp_div) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_exp_pickup==Y){
			$result = @mysql_query(
				"select SUM(exp_pickup) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_div_rec==Y){
			$result = @mysql_query(
				"select SUM(rec_div) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_diff==Y){
			$result = @mysql_query(
				"select SUM(diff) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field</p></td>\n";
			}
			}

			if ($show_retention==Y){
			$result = @mysql_query(
				"select ROUND(AVG(retention),2) from $this->dbName.$this->dbSpreadsheetTable where userID='$this->userID'");
			while ($get_info = mysql_fetch_row($result)){
			foreach ($get_info as $field);
			print "<td style=\"border-right:1px solid #009999\"><p>$field%</p></td>\n";
			}
			}

			if ($show_comments==Y){
			print "<td bgcolor=\"#E0F0F0\" style=\"border-right:1px solid #009999\">&nbsp;</td>\n";
			}

			print "</tr>\n";
			print "</table>\n";

			print "<input type=\"hidden\" name=\"userID\" value=\"$this->userID\">\n";
			print "<input type=\"hidden\" name=\"yearID\" value=\"$yearID\">\n";

			print "<p style=\"margin-bottom:16;margin-top:16\"><input type=\"submit\" value=\"Delete Selected Month(s) from Database\">\n";

			print "</form>\n";

			mysql_close();

		}


		function editRow($month, $userID, $yearID) {

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

			$result1 = @mysql_query(
				"select year from $this->dbName.$this->dbYearTable where yearID='$yearID'");

			while ($row = @mysql_fetch_assoc($result1)){
				$year = $row['year'];
			}

			$result = @mysql_query(
				"select * from $this->dbName.$this->dbSpreadsheetTable where month='$month' and userID='$userID' and yearID='$yearID'");

			if (mysql_num_rows($result) < 1) {
				print "<p style=\"font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 10.000000pt;margin-left: 10.000000pt;\">You've entered a month that doesn't exist.</p>\n";
				exit;
				}

			while ($row = @mysql_fetch_assoc($result)){

				$invoiced = $row['invoiced'];
				$tax = $row['tax'];
				$ni_ees = $row['ni_ees'];
				$ni_ers = $row['ni_ers'];
				$expenses = $row['expenses'];
				$interest = $row['interest'];
				$other_rev = $row['other_rev'];
				$pension = $row['pension'];
				$deductions = $row['deductions'];
				$rec_div = $row['rec_div'];
				$comments = $row['comments'];
			}

			?>

			<script language="JavaScript">

			function IsValidAmount(){
				var invoiced = document.form1.invoiced.value;
				var myreg
					= /(\d+\.\d+)|(\d+)/
				if (myreg.test(invoiced)) {
					return true;
				}
					else {
					alert("You have entered an invalid invoice amount.");
					return false;
				}
			}

			function IsValidTax(){
				var tax = document.form1.tax.value;
				var myreg
					= /(\d+\.\d+)|(\d+)/
				if (myreg.test(tax)) {
					return true;
				}
					else {
					alert("You have entered an invalid amount of tax.");
					return false;
				}
			}

			function IsValidNI_ees(){
				var ees = document.form1.ni_ees.value;
				var myreg
					= /(\d+\.\d+)|(\d+)/
				if (myreg.test(ees)) {
					return true;
				}
				else {
					alert("You have entered an invalid amount of employees NI.");
					return false;
				}
			}

			function IsValidNI_ers(){
				var ers = document.form1.ni_ers.value;
				var myreg
					= /(\d+\.\d+)|(\d+)/
				if (myreg.test(ers)) {
					return true;
				}
				else {
					alert("You have entered an invalid amount of employers NI.");
					return false;
				}
			}

			function IsValidExpenses(){
				var expenses = document.form1.expenses.value;
				var myreg
					= /(\d+\.\d+)|(\d+)|()/
				if (myreg.test(expenses)) {
					return true;
				}
				else {
					alert("You have entered an invalid amount of expenses.");
					return false;
				}
			}

			function IsValidInterest(){
				var interest = document.form1.interest.value;
				var myreg
					= /(\d+\.\d+)|(\d+)|()/
				if (myreg.test(interest)) {
					return true;
				}
				else {
					alert("You have entered an invalid amount of bank interest.");
					return false;
				}
			}

			function IsValidOtherRev(){
				var other_rev = document.form1.other_rev.value;
				var myreg
					= /(\d+\.\d+)|(\d+)|()/
				if (myreg.test(other_rev)) {
					return true;
				}
				else {
					alert("You have entered an invalid amount of other revenue.");
					return false;
				}
			}

			function IsValidPension(){
				var pension = document.form1.pension.value;
				var myreg
					= /(\d+\.\d+)|(\d+)|()/
				if (myreg.test(pension)) {
					return true;
				}
				else {
					alert("You have entered an invalid pension amount.");
					return false;
				}
			}

			function IsValidDeductions(){
				var deductions = document.form1.deductions.value;
				var myreg
					= /(\d+\.\d+)|(\d+)|()/
				if (myreg.test(deductions)) {
					return true;
				}
				else {
					alert("You have entered an invalid amount of deductions.");
					return false;
				}
			}

			function IsValidDividend(){
				var dividend = document.form1.rec_div.value;
				var myreg
					= /(\d+\.\d+)|(\d+)|()/
				if (myreg.test(dividend)) {
					return true;
				}
				else {
					alert("You have entered an invalid dividend.");
					return false;
				}
			}

			function checkfields() {
				if (IsValidAmount() == false) {
					return false;
				}
				if (IsValidTax() == false) {
					return false;
				}
				if (IsValidNI_ees() == false) {
					return false;
				}
				if (IsValidNI_ers() == false) {
					return false;
				}
				if (IsValidExpenses() == false) {
					return false;
				}
				if (IsValidInterest() == false) {
					return false;
				}
				if (IsValidOtherRev() == false) {
					return false;
				}
				if (IsValidPension() == false) {
					return false;
				}
				if (IsValidDeductions() == false) {
					return false;
				}
				if (IsValidDividend() == false) {
					return false;
				}
				return true;
			}
			</script>

			<p style="margin-left:2">Edit details for <? print "<b>$month</b>&nbsp;<b>$year</b>" ?></p>

			<form name="form1" method="post" action="editRow1.php" onSubmit='return checkfields();'>
			<input type="hidden" name="month" value="<? echo "$month" ?>">

			<input type="hidden" name="userID" value="<? echo "$userID" ?>">

			<input type="hidden" name="yearID" value="<? echo "$yearID" ?>">

			<table cellpadding="6" style="border-top:1px solid #009999;border-left:1px solid #009999;border-right:4px solid #009999;border-bottom:1px solid #009999;" cellpadding="0" cellspacing="0">

			<tr bgcolor="#009999" style="border:1px solid #009999">
			<td width="350pt" valign="top" style="border-right:1px solid #E0F0F0;">
			<p style="color:#FFFFFF;font-weight:bold;text-align:center;">Money Coming In</p>
			</td>
			<td width="350pt" valign="top">
			<p style="color:#FFFFFF;font-weight:bold;text-align:center;">Money Going Out</p>
			</td>
			</tr>
			<tr bgcolor="#E0F0F0" style="border-top:1px solid #009999;border-right:4px solid #009999;border-left:1px solid #009999;border-bottom:1px solid #009999;">
			<td valign="top" style="border-right:1px solid #009999;border-bottom:1px solid #009999;">
			<p>Amount Invoiced (net): <input type="text" name="invoiced" maxlength="10" size="10" value="<? echo "$invoiced" ?>"></p>
			<p>Bank Interest Received: <input type="text" name="interest" maxlength="10" size="10" value="<? echo "$interest" ?>"></p>
			<p>Other Revenue: <input type="text" name="other_rev" maxlength="10" size="10" value="<? echo "$other_rev" ?>"></p>
			</td>
			<td valign="top" style="border-bottom:1px solid #009999;">
			<p>Income Tax on Salary(ies): <input type="text" name="tax" maxlength="10" size="10" value="<? echo "$tax" ?>"></p>
			<p>Employees NI on Salary(ies): <input type="text" name="ni_ees" maxlength="10" size="10" value="<? echo "$ni_ees" ?>"></p>
			<p>Employers NI on Salary(ies): <input type="text" name="ni_ers" maxlength="10" size="10" value="<? echo "$ni_ers" ?>"></p>
			<p>Expenses Taken: <input type="text" name="expenses" maxlength="10" size="10" value="<? echo "$expenses" ?>"></p>
			<p>Pension Contributions: <input type="text" name="pension" maxlength="10" size="10" value="<? echo "$pension" ?>"></p>
			<p>Other Deductions: <input type="text" name="deductions" maxlength="10" size="10" value="<? echo "$deductions" ?>"></p>
			<p>Dividend Taken: <input type="text" name="rec_div" maxlength="10" size="10" value="<? echo "$rec_div" ?>"></p>
			</td>
			</tr>
			<tr bgcolor="#E0F0F0" style="border-top:1px solid #009999;border-right:4px solid #009999;border-left:1px solid #009999;border-bottom:1px solid #009999;">
			<td colspan="2">
			<p>Comments: <input type="text" name="comments" maxlength="100" size="50" value="<? echo "$comments" ?>">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
			<input type="submit" name="Submit" value="Update Values"></p>
			</td>
			</tr>
			</table>
			</form>

			<?php
		}


		function editRow1($month, $invoiced, $tax, $ni_ees, $ni_ers, $expenses, $interest, $other_rev, $pension, $deductions, $rec_div, $comments, $userID, $yearID) {

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

			$result = @mysql_query(
				"select * from $this->dbName.$this->dbSalaryTable where userID='$userID'");

			while ($row = @mysql_fetch_assoc($result)){

				$grs_salary = $row['grs_salary'];
				// VAT flat rate percentage
				$vat = $row['vat'];

				// Change VAT flat rate percentage to a multiplier
				// Eg change 12.00 to 0.12

  				$vat=$vat/100;

				$accountancy = $row['accountancy'];
				}

			// Calculate VAT
			$vat_amount=$invoiced*0.175;

			// Calculate gross receivable
			$grs_amount=$invoiced+$vat_amount;

			// Calculate VAT payable (accrued VAT)
			$vat_payable=$vat*$grs_amount;

			// Calculate VAT surplus (VAT charged - VAT payable)
			$vat_surplus=$vat_amount-$vat_payable;

			// Calculate net salary
			$net_salary=$grs_salary-($ni_ees+$tax);

			// Calculate corporation tax due
			$corporation_tax_temp=($invoiced+$interest+$other_rev+$vat_surplus)-($accountancy+$grs_salary+$ni_ers+$deductions+$expenses+$pension);

			$corporation_tax=0.21*$corporation_tax_temp;

			// Calculate maximum dividend
			$exp_div=($invoiced+$interest+$other_rev+$vat_surplus)-($accountancy+$grs_salary+$ni_ers+$deductions+$expenses+$pension+$corporation_tax);

			// Calculate the expected pickup
			$exp_pickup=$exp_div+$net_salary+$expenses;

			// Calculate the difference between the dividend taken and the maximum dividend
			// available
			$diff=$exp_div-$rec_div;

			// Check to make sure that there is an invoice amount.
			if ($invoiced > 0){
			$retention=100*($exp_pickup/$invoiced);
			}
			else {
			$retention=0.00;
			}

			// Check that more money has come in than has gone out
			$overpaymentCheck=($invoiced+$interest+$other_rev+$vat_surplus)-($accountancy+$grs_salary+$ni_ers+$deductions+$expenses+$rec_div+$pension+$corporation_tax);
			$outgoings=$accountancy+$grs_salary+$ni_ers+$deductions+$expenses+$rec_div+$pension+$corporation_tax;

			if ($overpaymentCheck<0.00){
			print "<p class=\"indent\">In $month, your company invoiced $invoiced, received $interest in bank interest, other revenue of $other_rev, plus a VAT surplus of $vat_surplus, but your salary, accountancy fee, employers NI, expenses taken, dividend taken, pension contributions, corporation tax, and any other deductions came to $outgoings. This gives a negative amount for this month of $overpaymentCheck. The running totals at the bottom of the spreadsheet, give the overall situation for this year.</p>\n" ;
			}

			$result = @mysql_query(
				"update $this->dbName.$this->dbSpreadsheetTable set invoiced='$invoiced', vat_amount='$vat_amount', grs_amount='$grs_amount', vat_payable='$vat_payable', vat_surplus='$vat_surplus', accountancy='$accountancy', grs_salary='$grs_salary', tax='$tax', ni_ees='$ni_ees', ni_ers='$ni_ers', net_salary='$net_salary', expenses='$expenses', interest='$interest', other_rev='$other_rev', pension='$pension', deductions='$deductions', corporation_tax='$corporation_tax', exp_div='$exp_div', exp_pickup='$exp_pickup', rec_div='$rec_div', diff='$diff', retention='$retention', comments='$comments', grs_salary='$grs_salary' where month='$month' and userID='$userID' and yearID='$yearID'");

			if ($result) {
			print "<p class=\"indent\">The row has been updated.</p>\n";
			}

			mysql_close();
		}

		function deleteRow() {

		$monthID=$_REQUEST['monthID']; // an array containing all the checked months
		$userID=$_REQUEST['userID'];
  		$yearID=$_REQUEST['yearID'];

			# count the number of months in $monthID and put the number in $num_months
  			$num_months = count($monthID);

			if ($num_months == 0) {
				print "<p style=\"font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 10.000000pt;margin-left: 10.000000pt;\">You have not selected any months to delete.</p>\n";
				print "<form>\n";
				print "<table width=\"100%\" style=\"margin-left:10px\"><tr><td>\n";
				print "<input type=button value=\"<- Go Back\" onClick=\"javascript:history.back();\">\n";
				print "</td></tr></table>\n";
				print "</form>\n";
				print "</td>\n";
				print "</tr></table>\n";
				exit;
				}

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

 			# Loop through the array and create $month_string, which contains something like:
 			# monthID = 'first_monthID' or monthID = 'second_monthID'

    		for ($i=0; $i<$num_months; $i++)
    			{
      			if ($i)
      				{
        			$month_string .= "or monthID = '".$monthID[$i]."' ";
					//$month_string = $month_string . "AND userID = '".$userID."' ";
        			//$month_string = $month_string . "AND yearID = '".$yearID."' ";
        			//$month_string = $month_string . ")";
      				}
      			else
      				{
        			$month_string .= "monthID = '".$monthID[$i]."' ";
        			//$month_string = $month_string . "AND userID = '".$userID."' ";
        			//$month_string = $month_string . "AND yearID = '".$yearID."' ";
      				}
				}

			# Delete month(s) from database

			//print $month_string;

			$result = @mysql_query(
				"DELETE from $this->dbName.$this->dbSpreadsheetTable where ($month_string)");

			print "<p class=\"indent\">The selected month(s) has/have been removed.</p>\n";

		mysql_close();

		}


		function listDividends() {
			// This method lists all the dividend tax vouchers that have been created for the current user. From here, an existing dividend tax voucher can be edited or deleted, or a new one can be created.

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

			$result = @mysql_query(
			"select * from $this->dbName.$this->dbDividendTable where userID='$this->userID'");

			print "<h3 style=\"font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 14.000000pt;background:#E0F0F0;font-weight:normal;margin-top:4.000000pt;margin-bottom: 14.000000pt;margin-right: 0.000000pt;margin-left: 0.000000pt;\">Create/Edit/Delete Dividend Tax Vouchers</h3>\n";

			if (mysql_num_rows($result) < 1) {
			print "<p style=\"font-family: Verdana, Arial, Helvetica, sans-serif;\">No dividend payments have been made to date</p>\n";

			print "<form method=\"post\" action=\"createDividend.php\">\n";

			print "<input type=\"submit\" name=\"Submit\" value=\"Create New Dividend Tax Voucher\">\n";

			print "</form>\n";

			exit;
			}

			print "<form method=\"post\" action=\"deleteDividend.php\">\n";

			print "<table border=\"0\" cellpadding=\"6\" cellspacing=\"0\" style=\"border-top:1px solid #009999;border-left:1px solid #009999;\">\n";

			print "<tr>\n";

			print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\" bgcolor=\"#E0F0F0\">&nbsp;</td>\n";

			print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\"><b>Date of Dividend Payment</b></p></td>\n";

			print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\"><b> Dividend Received</b></p></td>\n";

			print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\"><b>Non-Repayable Tax Credit</b></p></td>\n";

			print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\"><b>Gross Dividend</b></p></td>\n";

			print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\"><b>Share Holding</b></p></td>\n";

			print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\"><b>Dividend Rate</b></p></td>\n";

			print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\"><b>Recipient</b></p></td>\n";

			print "</tr>\n";


			// Define colors for the alternating rows
			$color1 = "#E0F0F0";
			$color2 = "#EEEEEE";
			$row_count = 0;

			while ($row = @mysql_fetch_assoc($result)){

				$dividendID = $row['dividendID'];
				$dividend_amount = $row['dividend_amount'];
				$tax_credit = $row['tax_credit'];
				$gross_dividend = $row['gross_dividend'];
				$period = $row['period'];
				$holding = $row['holding'];
				$dividend_rate = $row['dividend_rate'];
				$recipient_name = $row['recipient_name'];

				//Tell PHP to alternate the colors between the two colors defined above
				$row_color = ($row_count % 2) ? $color1 : $color2;

				print "<tr bgcolor=\"$row_color\">\n";

        		print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\">\n";

        		# Create an array to store all the selected dividend ids, which will
        		# be sent to deleteDividend.php

		    	print "<p style=\"text-align:center;\"><input type=\"checkbox\" name=\"dividendID[]\" value=\"$dividendID\"></p>\n";
        		print "</td>\n";

				print "<td valign=\"top\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\"><a href=\"editDividend.php?dividendID=$dividendID\">$period</a></p></td>\n";


				print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\">$dividend_amount</p></td>\n";

				print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\">$tax_credit</p></td>\n";

				print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\">$gross_dividend</p></td>\n";

				print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\">$holding</p></td>\n";

				print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\">$dividend_rate</p></td>\n";

				print "<td valign=\"top\" align=\"center\" style=\"border-right:1px solid #009999;border-bottom:1px solid #009999;\"><p style=\"text-align:center;\">$recipient_name</p></td>\n";

				print "</tr>\n";

    			// Add 1 to the row count
				$row_count++;

			}

			print "</table>\n";

			//print "<input type=\"hidden\" name=\"userID\" value=\"$this->userID\">\n";

			print "<p style=\"margin-bottom:16;margin-top:16\"><input type=\"submit\" value=\"Delete Selected Dividend Tax Voucher(s) from Database\">&nbsp;&nbsp;<input type=\"button\" value=\"Create New Dividend Tax Voucher\" onClick=\"self.location='createDividend.php'\"></p>\n";

			print "</form>\n";


		mysql_close();

		}


		function createDividend() {
			// This method is used as part of the process to enable a user to create a dividend tax voucher. It is called by createDividend.php. It provides a form to the user. The data from the form is sent to insertDividend.php.

			?>

			<!-- JavaScript to check that valid data is entered -->

			<script language="JavaScript">

			function IsNotNull()
			{
				if (document.form1.dividend_amount == null ||
					document.form1.period == null ||
					document.form1.year_end == null ||
					document.form1.meeting_date == null ||
					document.form1.company == null ||
					document.form1.holding == null ||
					document.form1.recipient_name == null) {
					alert("Please complete the Dividend Received, Date of Dividend, Company Year End Date, Meeting Date, Company Name, Holding, and Recipient Name fields.");
					return false;
					}
				if (document.form1.dividend_amount.value.length == 0 ||
					document.form1.period.value.length == 0 ||
					document.form1.year_end.value.length == 0 ||
					document.form1.meeting_date.value.length == 0 ||
					document.form1.company.value.length == 0 ||
					document.form1.holding.value.length == 0 ||
					document.form1.recipient_name.value.length == 0) {
					alert("Please complete the Dividend Received, Date of Dividend, Company Year End Date, Meeting Date, Company Name, Holding, and Recipient Name fields.");
					return false;
					}
				return true;
			}

			function IsValidDividend(){
				var dividend_amount = document.form1.dividend_amount.value;
				var myreg
					= /(\d+\.\d+)|(\d+)/
				if (myreg.test(dividend_amount)) {
					return true;
				}
				else {
					alert("You have entered an invalid value for dividend received.");
					return false;
				}
			}

			function IsValidRate(){
				var dividend_rate = document.form1.dividend_rate.value;
				var myreg
					= /(\d+\.\d+)|(\d+)/
				if (myreg.test(dividend_rate)) {
					return true;
				}
				else {
					alert("You have entered an invalid value for the dividend rate.");
					return false;
				}
			}

			function IsValidHolding(){
				var holding = document.form1.holding.value;
				var myreg
					= /(\d+)/
				if (myreg.test(holding)) {
					return true;
				}
				else {
					alert("You have entered an invalid value for the holding.");
					return false;
				}
			}

			function checkfields() {

				if (IsNotNull() == false) {
					return false;
				}

				if (IsValidDividend() == false) {
					return false;
				}

				if (IsValidHolding() == false) {
					return false;
				}

				return true;
			}
			</script>


			<h3>Create a New Dividend Tax Voucher</h3>

			<p>Use this form to create a new dividend tax voucher.</p>

			<p>Fields marked with an asterisk (*) are compulsory.</p>

			<br>

			<table cellpadding="6">
			<tr>
			<td bgcolor="#E0F0F0" style="border-top:1px solid #009999;border-right:4px solid #009999;border-left:1px solid #009999;border-bottom:1px solid #009999;">

			<form name="form1" method="post" action="insertDividend.php" onSubmit='return checkfields();'>

			<p>Dividend Received: <input type="text" name="dividend_amount" maxlength="11" size="11">* <i>(Enter the net amount received, for example, 1234 or 1234.00)</i></p>

			<p>Date of Dividend: <input type="text" name="period" maxlength="30" size="30">*<i> (Enter up to 30 characters of free format text)</i></p>

			<p>Company Year End Date: <input type="text" name="year_end" maxlength="30" size="30">*<i> (Enter up to 30 characters of free format text)</i></p>

			<p>Company Meeting Date: <input type="text" name="meeting_date" maxlength="30" size="30">*<i> (Enter up to 30 characters of free format text)</i></p>

			<p>Company Name: <input type="text" name="company" maxlength="50" size="50">*<i> (Enter up to 50 characters of free format text)</i> </p>

			<p>Company Address Line 1: <input type="text" name="company_address_line_1" maxlength="50" size="50"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<p>Company Address Line 2: <input type="text" name="company_address_line_2" maxlength="50" size="50"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<p>Company Address Line 3: <input type="text" name="company_address_line_3" maxlength="50" size="50"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<p>Company Address Line 4: <input type="text" name="company_address_line_4" maxlength="50" size="50"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<p>Holding (number of shares held): <input type="text" name="holding" maxlength="10" size="10">* <i>(Enter the number of shares help, for example, 50)</i></p>

			<!--
			<p>Dividend Rate: <input type="text" name="dividend_rate" maxlength="8" size="8">* <i>(Enter the dividend rate, for example, 12 or 12.00)</i> </p>
			-->

			<p>Recipient Name: <input type="text" name="recipient_name" maxlength="50" size="50">*<i> (Enter up to 50 characters of free format text)</i></p>

			<p>Recipient Address Line 1: <input type="text" name="recipient_address_line_1" maxlength="50" size="50"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<p>Recipient Address Line 2: <input type="text" name="recipient_address_line_2" maxlength="50" size="50"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<p>Recipient Address Line 3: <input type="text" name="recipient_address_line_3" maxlength="50" size="50"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<p>Recipient Address Line 4: <input type="text" name="recipient_address_line_4" maxlength="50" size="50"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<br>
			<p><input type="submit" name="Submit" value="Create Dividend Tax Voucher"></p>
			</form>
			</td>
			</tr>
			</table>

			<?php

		}


		function insertDividend () {
		// This method is used as part of the process to create a new dividend tax voucher. It is called by insertDividend.php.

			// Get data

			$dividend_amount=$_REQUEST['dividend_amount'];
			$period=$_REQUEST['period'];
			$year_end=$_REQUEST['year_end'];
			$meeting_date=$_REQUEST['meeting_date'];
			$company=$_REQUEST['company'];
			$company_address_line_1=$_REQUEST['company_address_line_1'];
			$company_address_line_2=$_REQUEST['company_address_line_2'];
			$company_address_line_3=$_REQUEST['company_address_line_3'];
			$company_address_line_4=$_REQUEST['company_address_line_4'];
			$holding=$_REQUEST['holding'];
			$recipient_name=$_REQUEST['recipient_name'];
			$recipient_address_line_1=$_REQUEST['recipient_address_line_1'];
			$recipient_address_line_2=$_REQUEST['recipient_address_line_2'];
			$recipient_address_line_3=$_REQUEST['recipient_address_line_3'];
			$recipient_address_line_4=$_REQUEST['recipient_address_line_4'];

			// Calculate values

			$tax_credit1=$dividend_amount*1.1111111;
			$tax_credit=$tax_credit1-$dividend_amount;

			$gross_dividend=$dividend_amount+$tax_credit;

			$dividend_rate=$dividend_amount/$holding;

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

			$result = mysql_query(
					"insert into $this->dbName.$this->dbDividendTable
					(dividend_amount, tax_credit,  gross_dividend, period, year_end, meeting_date, company, company_address_line_1, company_address_line_2, company_address_line_3, company_address_line_4, holding, dividend_rate, recipient_name, recipient_address_line_1, recipient_address_line_2, recipient_address_line_3, recipient_address_line_4, userID) values
					('$dividend_amount', '$tax_credit', '$gross_dividend', '$period', '$year_end', '$meeting_date', '$company', '$company_address_line_1', '$company_address_line_2', '$company_address_line_3', '$company_address_line_4', '$holding', '$dividend_rate', '$recipient_name', '$recipient_address_line_1', '$recipient_address_line_2', '$recipient_address_line_3', '$recipient_address_line_4', '$this->userID')");

			// If update worked, display the tax voucher
			if ($result) {

				?>

				<style type="text/css">
				@media print {
				input#printButton {
				display: none;
				}
				}
				</style>

				<input type="button" id="printButton" onclick="window.print();" value="Print Voucher" />

				<?php

				print "<table border=\"0\">\n";
				print "<tr>\n";

				print "<td align=\"center\" colspan=\"2\"><p style=\"text-align:center;\"><b>$company</b><br>$company_address_line_1<br>$company_address_line_2<br>$company_address_line_3<br>$company_address_line_4</p></td>\n";

				print "</tr>\n";


				print "<tr>\n";

				print "<td align=\"center\" colspan=\"2\"><p style=\"text-align:center;font-size:16pt;font-weight:bold;margin-top:50;margin-bottom:50;\">TAX VOUCHER</p></td>\n";

				print "</tr>\n";

				print "<tr>\n";

				print "<td colspan=\"2\"><p style=\"margin-left:50;margin-right:50;margin-top:30;margin-bottom:30;\">Dividend for the year ended $year_end, payable to holders registered on $meeting_date. Date of payment, $period.</p></td>\n";

				print "</tr>\n";

				print "<tr>\n";

				print "<td><p style=\"margin-left:50;\">Holding:</p></td><td width=\"350\"><p>$holding Ordinary Shares</p></td>\n";

				print "</tr>\n";


				print "<tr>\n";

				$dividend_rate=round($dividend_rate, 2);

				print "<td><p style=\"margin-left:50;\">Dividend Rate:</p></td><td><p>$dividend_rate per share</p></td>\n";

				print "</tr>\n";

				print "<tr>\n";

				$dividend_amount=round($dividend_amount, 2);

				print "<td><p style=\"margin-left:50;\">Dividend Payable:</p></td><td><p>$dividend_amount</p></td>\n";

				print "</tr>\n";

				print "<tr>\n";

				$tax_credit=round($tax_credit, 2);

				print "<td><p style=\"margin-left:50;\">Tax Credit:</p></td><td><p>$tax_credit</p></td>\n";

				print "</tr>\n";


				print "<tr>\n";

				print "<td colspan=\"2\"><p style=\"margin-left:50;margin-right:50;margin-top:30;margin-bottom:30\">This voucher should be kept. It will be accepted by HM Revenue &amp; Customs as evidence of a tax credit.</p></td>\n";

				print "</tr>\n";

				print "<tr>\n";

				print "<td colspan=\"2\"><p style=\"margin-left:50;margin-right:50;margin-top:100;\">...........................<br>Company Secretary</p></td>\n";

				print "</tr>\n";

				print "<tr>\n";

				print "<td colspan=\"2\"><p style=\"margin-left:50;margin-right:50;margin-top:100;\">$recipient_name<br>$recipient_address_line_1<br>$recipient_address_line_2<br>$recipient_address_line_3<br>$recipient_address_line_4</p></td>\n";

				print "</tr>\n";

				print "</table>\n";

				?>

				<style type="text/css">
				@media print {
				input#printButton {
				display: none;
				}
				}
				</style>

				<input type="button" id="printButton" onclick="window.print();" value="Print Voucher" />

				<?php

			}

			// If update did not work, display an error message
			else {
				print "<p class=\"indent\">There was a problem creating the tax voucher.</p>\n";
				exit;
			}

			mysql_close();
		}


		function deleteDividend() {

		$dividendID=$_REQUEST['dividendID']; // an array containing all the checked dividends

			# count the number of items in $dividendID and put the number in $num_dividends
  			$num_dividends = count($dividendID);

			if ($num_dividends == 0) {
				print "<p style=\"font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 10.000000pt;margin-left: 10.000000pt;\">You have not selected any dividend tax vouchers to delete.</p>\n";
				print "<form>\n";
				print "<table width=\"100%\" style=\"margin-left:10px\"><tr><td>\n";
				print "<input type=button value=\"<- Go Back\" onClick=\"javascript:history.back();\">\n";
				print "</td></tr></table>\n";
				print "</form>\n";
				print "</td>\n";
				print "</tr></table>\n";
				exit;
				}

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

 			# Loop through the array and create $dividend_string, which contains something like:
 			# dividendID = 'first_dividendID' or dividendID = 'second_dividendID'

    		for ($i=0; $i<$num_dividends; $i++)
    			{
      			if ($i)
      				{
        			$dividend_string .= "or dividendID = '".$dividendID[$i]."' ";
      				}
      			else
      				{
        			$dividend_string .= "dividendID = '".$dividendID[$i]."' ";
      				}
				}

			# Delete dividend(s) from database

			$result = @mysql_query(
				"DELETE from $this->dbName.$this->dbDividendTable where ($dividend_string)");

			print "<p class=\"indent\">The selected dividend tax voucher(s) has/have been removed.</p>\n";

		mysql_close();

		}

		function editDividend($dividendID) {

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

			$result = @mysql_query(
				"select * from $this->dbName.$this->dbDividendTable where dividendID='$dividendID'");

			while ($row = @mysql_fetch_assoc($result)){

				$dividend_amount = $row['dividend_amount'];
				$period = $row['period'];
				$year_end = $row['year_end'];
				$meeting_date = $row['meeting_date'];
				$company = $row['company'];
				$company_address_line_1 = $row['company_address_line_1'];
				$company_address_line_2 = $row['company_address_line_2'];
				$company_address_line_3 = $row['company_address_line_3'];
				$company_address_line_4 = $row['company_address_line_4'];
				$holding = $row['holding'];
				$recipient_name = $row['recipient_name'];
				$recipient_address_line_1 = $row['recipient_address_line_1'];
				$recipient_address_line_2 = $row['recipient_address_line_2'];
				$recipient_address_line_3 = $row['recipient_address_line_3'];
				$recipient_address_line_4 = $row['recipient_address_line_4'];

			}

			?>

			<!-- JavaScript to check that valid data is entered -->

			<script language="JavaScript">

			function IsNotNull()
			{
				if (document.form1.dividend_amount == null ||
					document.form1.period == null ||
					document.form1.year_end == null ||
					document.form1.meeting_date == null ||
					document.form1.company == null ||
					document.form1.holding == null ||
					document.form1.recipient_name == null) {
					alert("Please complete the Dividend Received, Date of Dividend, Company Year End Date, Meeting Date, Company Name, Holding, and Recipient Name fields.");
					return false;
					}
				if (document.form1.dividend_amount.value.length == 0 ||
					document.form1.period.value.length == 0 ||
					document.form1.year_end.value.length == 0 ||
					document.form1.meeting_date.value.length == 0 ||
					document.form1.company.value.length == 0 ||
					document.form1.holding.value.length == 0 ||
					document.form1.recipient_name.value.length == 0) {
					alert("Please complete the Dividend Received, Date of Dividend, Company Year End Date, Meeting Date, Company Name, Holding, and Recipient Name fields.");
					return false;
					}
				return true;
			}

			function IsValidDividend(){
				var dividend_amount = document.form1.dividend_amount.value;
				var myreg
					= /(\d+\.\d+)|(\d+)/
				if (myreg.test(dividend_amount)) {
					return true;
				}
				else {
					alert("You have entered an invalid value for dividend received.");
					return false;
				}
			}

			function IsValidRate(){
				var dividend_rate = document.form1.dividend_rate.value;
				var myreg
					= /(\d+\.\d+)|(\d+)/
				if (myreg.test(dividend_rate)) {
					return true;
				}
				else {
					alert("You have entered an invalid value for the dividend rate.");
					return false;
				}
			}

			function IsValidHolding(){
				var holding = document.form1.holding.value;
				var myreg
					= /(\d+)/
				if (myreg.test(holding)) {
					return true;
				}
				else {
					alert("You have entered an invalid value for the holding.");
					return false;
				}
			}

			function checkfields() {

				if (IsNotNull() == false) {
					return false;
				}

				if (IsValidDividend() == false) {
					return false;
				}

				if (IsValidHolding() == false) {
					return false;
				}

				return true;
			}
			</script>


			<h3>Edit an Existing Dividend Tax Voucher</h3>

			<p>Use this form to edit an existing dividend tax voucher.</p>

			<p>Fields marked with an asterisk (*) are compulsory.</p>

			<br>

			<table cellpadding="6">
			<tr>
			<td bgcolor="#E0F0F0" style="border-top:1px solid #009999;border-right:4px solid #009999;border-left:1px solid #009999;border-bottom:1px solid #009999;">

			<form name="form1" method="post" action="updateDividend.php" onSubmit='return checkfields();'>

			<p>Dividend Received: <input type="text" name="dividend_amount" maxlength="11" size="11" value="<? echo "$dividend_amount" ?>">* <i>(Enter the net amount received, for example, 1234 or 1234.00)</i></p>

			<p>Date of Dividend: <input type="text" name="period" maxlength="30" size="30" value="<? echo "$period" ?>">*<i> (Enter up to 30 characters of free format text)</i></p>

			<p>Company Year End Date: <input type="text" name="year_end" maxlength="30" size="30" value="<? echo "$year_end" ?>">*<i> (Enter up to 30 characters of free format text)</i></p>

			<p>Company Meeting Date: <input type="text" name="meeting_date" maxlength="30" size="30" value="<? echo "$meeting_date" ?>">*<i> (Enter up to 30 characters of free format text)</i></p>

			<p>Company Name: <input type="text" name="company" maxlength="50" size="50" value="<? echo "$company" ?>">*<i> (Enter up to 50 characters of free format text)</i> </p>

			<p>Company Address Line 1: <input type="text" name="company_address_line_1" maxlength="50" size="50" value="<? echo "$company_address_line_1" ?>"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<p>Company Address Line 2: <input type="text" name="company_address_line_2" maxlength="50" size="50" value="<? echo "$company_address_line_2" ?>"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<p>Company Address Line 3: <input type="text" name="company_address_line_3" maxlength="50" size="50" value="<? echo "$company_address_line_3" ?>"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<p>Company Address Line 4: <input type="text" name="company_address_line_4" maxlength="50" size="50" value="<? echo "$company_address_line_4" ?>"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<p>Holding (number of shares held): <input type="text" name="holding" maxlength="10" size="10" value="<? echo "$holding" ?>">* <i>(Enter the number of shares help, for example, 50)</i></p>

			<p>Recipient Name: <input type="text" name="recipient_name" maxlength="50" size="50" value="<? echo "$recipient_name" ?>">*<i> (Enter up to 50 characters of free format text)</i></p>

			<p>Recipient Address Line 1: <input type="text" name="recipient_address_line_1" maxlength="50" size="50" value="<? echo "$recipient_address_line_1" ?>"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<p>Recipient Address Line 2: <input type="text" name="recipient_address_line_2" maxlength="50" size="50" value="<? echo "$recipient_address_line_2" ?>"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<p>Recipient Address Line 3: <input type="text" name="recipient_address_line_3" maxlength="50" size="50" value="<? echo "$recipient_address_line_3" ?>"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<p>Recipient Address Line 4: <input type="text" name="recipient_address_line_4" maxlength="50" size="50" value="<? echo "$recipient_address_line_4" ?>"><i> (Optionally, enter up to 50 characters of free format text)</i></p>

			<input type="hidden" name="dividendID" value="<? echo "$dividendID" ?>">

			<br>
			<p><input type="submit" name="Submit" value="Submit Updates to Dividend Tax Voucher"></p>
			</form>
			</td>
			</tr>
			</table>

			<?php
		}


		function updateDividend ($dividendID, $dividend_amount, $period, $year_end, $meeting_date, $company, $company_address_line_1, $company_address_line_2, $company_address_line_3, $company_address_line_4, $holding, $recipient_name, $recipient_address_line_1, $recipient_address_line_2, $recipient_address_line_3, $recipient_address_line_4) {

		// This method is used as part of the process to edit an existing dividend tax voucher. It is called by updateDividend.php.

			// Calculate values

			$tax_credit1=$dividend_amount*1.1111111;
			$tax_credit=$tax_credit1-$dividend_amount;

			$gross_dividend=$dividend_amount+$tax_credit;

			$dividend_rate=$dividend_amount/$holding;

			mysql_connect("$this->dbHost", "$this->dbUser", "$this->dbPass");

			$result = @mysql_query(
				"update $this->dbName.$this->dbDividendTable set dividend_amount='$dividend_amount', tax_credit='$tax_credit', gross_dividend='$gross_dividend', period='$period', year_end='$year_end', meeting_date='$meeting_date', company='$company', company_address_line_1='$company_address_line_1', company_address_line_2='$company_address_line_2', company_address_line_3='$company_address_line_3', company_address_line_4='$company_address_line_4', holding='$holding', dividend_rate='$dividend_rate', recipient_name='$recipient_name', recipient_address_line_1='$recipient_address_line_1', recipient_address_line_2='$recipient_address_line_2', recipient_address_line_3='$recipient_address_line_3', recipient_address_line_4='$recipient_address_line_4' where dividendID='$dividendID' and userID='$this->userID'");

			// If update worked, display the tax voucher
			if ($result) {

				?>

				<style type="text/css">
				@media print {
				input#printButton {
				display: none;
				}
				}
				</style>

				<input type="button" id="printButton" onclick="window.print();" value="Print Voucher" />

				<?php

				print "<table border=\"0\">\n";
				print "<tr>\n";

				print "<td align=\"center\" colspan=\"2\"><p style=\"text-align:center;\"><b>$company</b><br>$company_address_line_1<br>$company_address_line_2<br>$company_address_line_3<br>$company_address_line_4</p></td>\n";

				print "</tr>\n";


				print "<tr>\n";

				print "<td align=\"center\" colspan=\"2\"><p style=\"text-align:center;font-size:16pt;font-weight:bold;margin-top:50;margin-bottom:50;\">TAX VOUCHER</p></td>\n";

				print "</tr>\n";

				print "<tr>\n";

				print "<td colspan=\"2\"><p style=\"margin-left:50;margin-right:50;margin-top:30;margin-bottom:30;\">Dividend for the year ended $year_end, payable to holders registered on $meeting_date. Date of payment, $period.</p></td>\n";

				print "</tr>\n";

				print "<tr>\n";

				print "<td><p style=\"margin-left:50;\">Holding:</p></td><td width=\"350\"><p>$holding Ordinary Shares</p></td>\n";

				print "</tr>\n";


				print "<tr>\n";

				$dividend_rate=round($dividend_rate, 2);

				print "<td><p style=\"margin-left:50;\">Dividend Rate:</p></td><td><p>$dividend_rate per share</p></td>\n";

				print "</tr>\n";

				print "<tr>\n";

				$dividend_amount=round($dividend_amount, 2);

				print "<td><p style=\"margin-left:50;\">Dividend Payable:</p></td><td><p>$dividend_amount</p></td>\n";

				print "</tr>\n";

				print "<tr>\n";

				$tax_credit=round($tax_credit, 2);

				print "<td><p style=\"margin-left:50;\">Tax Credit:</p></td><td><p>$tax_credit</p></td>\n";

				print "</tr>\n";


				print "<tr>\n";

				print "<td colspan=\"2\"><p style=\"margin-left:50;margin-right:50;margin-top:30;margin-bottom:30\">This voucher should be kept. It will be accepted by HM Revenue &amp; Customs as evidence of a tax credit.</p></td>\n";

				print "</tr>\n";

				print "<tr>\n";

				print "<td colspan=\"2\"><p style=\"margin-left:50;margin-right:50;margin-top:100;\">...........................<br>Company Secretary</p></td>\n";

				print "</tr>\n";

				print "<tr>\n";

				print "<td colspan=\"2\"><p style=\"margin-left:50;margin-right:50;margin-top:100;\">$recipient_name<br>$recipient_address_line_1<br>$recipient_address_line_2<br>$recipient_address_line_3<br>$recipient_address_line_4</p></td>\n";

				print "</tr>\n";

				print "</table>\n";

				?>

				<style type="text/css">
				@media print {
				input#printButton {
				display: none;
				}
				}
				</style>

				<input type="button" id="printButton" onclick="window.print();" value="Print Voucher" />

				<?php

			}

			// If update did not work, display an error message
			else {
				print "<p class=\"indent\">There was a problem editing the tax voucher.</p>\n";
				exit;
			}

			mysql_close();
		}



	} // End Spreadsheet class definition

?>